/*
 *  dynamics.hpp
 *  Template
 *
 *  Created by increpare on 16/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */



#include <boost/format.hpp>
#include <boost/assign/list_of.hpp> 
using namespace boost::assign; 
using namespace boost;






inline void scale(num& quantity,num amount,num max)
{
	if (amount>0)
		quantity+=amount*(max-quantity);
	else
		quantity+=amount*(quantity);		
}


/*

	Actions
 
 */

class Action {
public:
	num* quantity;
	num amount;
	num duration;
	Action(num* q, num am, num dur): quantity(q),amount(am),duration(dur){};
	Action(const Action& a):
	quantity(a.quantity),
	amount(a.amount),
	duration(a.duration)
	{}
};

const Action do_nothing(NULL,0,0);

list<Action> actions;

void add_action(num* quantity, num amount, num duration)
{
	Action action(quantity, amount, duration);
	actions.push_back(action);
}

void add_action(Action action)
{
	actions.push_back(action);
}

bool nullTime (Action e)
{
	return (e.duration<=0);
}

void process_actions()
{
	
	actions.erase(remove_if(actions.begin(), actions.end(), nullTime),actions.end());
	
	foreach(Action e,actions)
	{
		scale(*e.quantity,e.amount,1);
		e.duration--;
	}
}

/*
 
 Events
 
 */

#include "functionobs.hpp"

class Event {
public:
	string message;
	vector<Condition> conditions;
	Action action;
	Event(string mes,vector<Condition> con,Action act):message(mes),conditions(con),action(act){};
};

class Notice {
public:
//	Notice(
};

vector<Event> events;

class conditionmet {
public:
	bool operator() (const Event& e)
	{
		bool flag=true;
		foreach (Condition c,e.conditions)
		if (!less_than(c)())
		{
			flag=false;
			break;
		}
		return flag;
	}
};

void check_events()
{
		foreach(Event e, events)
		{
			bool met=true;
			foreach (Condition c,e.conditions)
				if (!less_than(c)())
				{
					met=false;
					break;
				}
			
			if (met)
			{
				showDialog(e.message);
				add_action(e.action);
			}
		}
	
	events.erase(remove_if(events.begin(),events.end(),conditionmet()),events.end());
}

/*
 
 System setup
 
 */

typedef vector<num> vec;

enum peoples {
	Polish = 0,
	Jewish = 1,
	German = 2
};



void add_event(string s, vector<Condition> c, const Action& a)
{
	events.push_back(Event(s,c,a));
}

class Warsaw
	{
	public:
		//inputs buttons
		bool educationban;
		bool ghetto;
		bool wall;
		bool jewbadge;
		bool polebadge;
		bool trains;
		
		//input sliders
		num tax;
		num propaganda;
		num military;
		num immigration;
		
		//output sliders
		num population;
		num polishpop[2];
		num jewishpop[2];
		num germanpop;
		num budget;
				
		//time/date
		int month;
		int year;
		int time;
		
		//hidden parameters
		num jewishresistance;
		num polishresistance;
		num totalresistance;
		
		Warsaw():
		educationban(false),
		ghetto(false),
		wall(false),
		jewbadge(false),
		polebadge(false),
		trains(false),
		tax(0.2),
		propaganda(0.2),
		military(0.8),
		immigration(0.2),
		germanpop(0.05),
		budget(0.8),
		month(9),
		year(0),
		time(0),
		jewishresistance(0.7),
		polishresistance(0.3),
		totalresistance(0)
		{
			jewishpop[0]=0.0;
			jewishpop[1]=0.5;
			polishpop[0]=0.0;
			polishpop[1]=0.4;
			
			population=(jewishpop[0]+jewishpop[1])/3+polishpop[0]+polishpop[1]+germanpop;

			events.clear();
			actions.clear();
			
			add_event("general government is established",
					  list_of
						(Condition(0,1)),
					  do_nothing);
			
			add_event("the jews have been successfully moved",
					  list_of
						(Condition(&(jewishpop[1]),0.02))
						(Condition(0.02,&(jewishpop[0]))),
					  do_nothing);
			
			add_event("the poles have been successfully moved",
					  list_of
					  (Condition(&(polishpop[1]),0.02))
					  (Condition(0.02,&(polishpop[0]))),
					  do_nothing);
			
			add_event("the jews have been eradicated",
					  list_of
						(Condition(&(jewishpop[0]),0.02))
						(Condition(&(jewishpop[1]),0.02)),
					  do_nothing);
			
			add_event("the poles are being relocated",
					  list_of
						(Condition(0.01,&(polishpop[0]))),
					  do_nothing);
			
			add_event("we are running low on funds",
					  list_of
						(Condition(&(budget),0.1)),
					  do_nothing);
			
			add_event("we have no money left",
					  list_of
						(Condition(&budget,0.015)),
					  do_nothing);
			
			add_event("we are being overthrown",
					  list_of
					  (Condition(&germanpop,0.015)),
					  do_nothing);
			
			
			add_event("deportation has begun",
					  list_of
						(TruthCondition(&trains)),
					  do_nothing);
			
			add_event("the students are rioting",
					  list_of
					   (TruthCondition(&educationban)),
					  Action(&jewishresistance, 0.03, 20));

			add_event("",
					  list_of
					  (TruthCondition(&educationban)),
					  Action(&polishresistance, 0.03, 20));

			add_event("",
					  list_of
					  (TruthCondition(&jewbadge)),
					  Action(&jewishresistance, 0.03, 10));
			
			add_event("",
					  list_of
					  (TruthCondition(&polebadge)),
					  Action(&polishresistance, 0.03, 10));
			
			add_event("construction of the wall begun",
					  list_of
					  (TruthCondition(&wall)),
					  Action(&budget, -0.02, 3));
		}
		
		int tick();
		void incrementtime();
	};

const num migvel=0.002;
const num moneycollect=0.03;
int Warsaw::tick()
{
	
	//need resistance values for each group; have mortality be a combination of resistance and military spending
	//propaganda can cut down on resistance
	//resistance without defence will result in decrease of german population
	
	//impossible to raise immigration rate while local population high
	//wall double transfer rate into ghetto; reduces resistance (thoguh initial rise via event, maybe)
	
	//military stifles resistance effects, propaganda decreases it's real amount slowly.
	//population should decrease slightly in proportion to military*resistance
	
	if (budget<0.01)
	{
		return 1;
	}

	if (germanpop<0.01)
	{
		return 2;
	}
	
	num polishpopgrowth[2]={0,0};
	num jewishpopgrowth[2]={0,0};
	
	num budgetgrowth=0;
	if (ghetto)
	{
		if (jewishpop[1]>0.002)
		{
			jewishpopgrowth[0]+=migvel;
			jewishpopgrowth[1]+=-migvel;
			budgetgrowth+=moneycollect*jewishpop[1];
		}

		
		if (jewishpop[0]+jewishpop[1] <0.03)
		{
			if (polishpop[1]>0.002)
			{
				polishpopgrowth[0]+=migvel/2;//because polish pop is rated twice jewish pop
				polishpopgrowth[1]+=-migvel/2;
				budgetgrowth+=moneycollect*jewishpop[1];
			}
			
			if (trains&&polishpop[0]>0.1)
			{
				if (polishpop[0]>0.002)
				{
					polishpopgrowth[0]+=-migvel;
					budgetgrowth+=moneycollect*polishpop[0];
				}

			}
		}
	}

	
	if (trains)
	{
		if (jewishpop[0]>0.002)
		{
			jewishpopgrowth[0]+=-2*migvel;
			budgetgrowth+=0.004*jewishpop[0];
		}
	}
	
//	scale(jewishresistance,jewishpop[0]
		  
	num coeff=(wall?0.05:0.1);
	
	num jewishresistancechange=0.0001+0.0001*jewbadge+jewishpop[0]*coeff+jewishpop[1]*0.05*tax-propaganda*0.02-educationban*0.0015;

	num polishresistancechange=0.0001*polebadge+polishpop[0]*coeff+polishpop[1]*0.05*tax-propaganda*0.05-educationban*0.02;
	
	//resistances grow slower if groups are separated
	if (polishresistance<jewishresistance )
	{
		if (jewbadge!=polebadge)
			polishresistancechange+=0.2*jewishpop[1];
	}
	else //if(polishresistance>jewishresistance && (jewbadge!=polebadge))
	{
		if (jewbadge!=polebadge)
			jewishresistance+=0.2*polishpop[0];		
	}
	
	scale(jewishresistance,jewishresistancechange,1);
	scale(polishresistance,polishresistancechange,1);
	
	totalresistance=jewishresistance*(jewishpop[0]+jewishpop[1])+polishresistance*(polishpop[0]+polishpop[1]);
	
	num resistancecand=(totalresistance<1?totalresistance:1)*0.1-military*0.1;
	if (resistancecand<0)
		resistancecand=0;
	num germanpopgrowth=0.0001*immigration-(resistancecand<0?0:resistancecand)*0.25;
	
	scale(polishresistance,polishresistancechange,1);
	scale(jewishresistance,jewishresistancechange,1);

	scale(jewishpop[0],jewishpopgrowth[0],0.5);
	scale(jewishpop[1],jewishpopgrowth[1],0.5);
	scale(polishpop[0],polishpopgrowth[0],1);
	scale(polishpop[1],polishpopgrowth[1],1);
	
	if (polishpop[0]+polishpop[1] > 1)
		polishpop[0]=1-polishpop[1];
	if (jewishpop[0]+jewishpop[1] > 1)
		jewishpop[0]=1-jewishpop[1];
	scale(germanpop,germanpopgrowth,1);
	
	population=((jewishpop[0]+jewishpop[1])/3+polishpop[0]+polishpop[1]+germanpop);
	if (population>1)
	{
		//kill twice as many germans as others; if that doesn't help things, then kill off others
		scale(germanpop,-0.01,1);
		scale(polishpop[0],-0.005,1);
		scale(polishpop[1],-0.005,1);
		scale(jewishpop[0],-0.005,1);
		scale(jewishpop[1],-0.005,1);
		population=1;
	}
	
	budgetgrowth+=-0.005*propaganda-0.01*military+0.01*tax*(germanpop+(jewishpop[1]+polishpop[1])/3);
	scale(budget,budgetgrowth,1);

//	jewishpop[1]+=jewishpopgrowth[1]*(0.5-population);
	incrementtime();
	return 0;
};

void Warsaw::incrementtime()
{
	time++;
	//30 fps
	//120 seconds per year
	//120*30
	if (time%(3*30)==0)
	{
		month=(month+1)%12;
		if (month==0)
			year++;
		
		if (month==10 && year==5)
			warover=true;
	}
	
	if (time%10 ==0)
	{
		changeflame=true;
		
		int s=rand()%50;
		int r=rand()%4;
		flame[s][0]=flameboxes[r][0]+(rand()%(flameboxes[r][2]-flameboxes[r][0]));
		flame[s][1]=flameboxes[r][1]+(rand()%(flameboxes[r][3]-flameboxes[r][1]));
		flame[s][2]=flamecycle[rand()%flamecyclelength];
		
	}
	
	
};

Warsaw* warsaw;



int do_logic()
{
	check_events();
	process_actions();
	return warsaw->tick();	
}
