/*
 
 todo: set quantities
 todo: tie widget quntities to game variables
 todo: set up timeline
 todo: set up dynamics
 todo: set up dialogs
 todo: release resources?
 todo: allow events to, like, end the game, or whatever
 todo: playsample doesn't seem to work:/
 todo: when pop bars move left, blood spatter
 todo: as population decreases, blot out parts of the city
 todo: as population increases, add new bits in(i guess)
 
 todo: ALLOW INGAME RESTART
 */
#include <allegro.h>
#include <iostream>
#include <vector>
#include <list>
#include <time.h>
#include <algorithm>
#include "boost/foreach.hpp"
//mac #include <ApplicationServices/ApplicationServices.h>

using namespace std;

#define foreach BOOST_FOREACH

typedef float num;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

void drawGUI();
void drawCursor();
void showDialog(string s);
void init_gamevars();

BITMAP* titlebutton[2];
BITMAP* bitmaparray[14];
BITMAP *buffer;
BITMAP* titlescreen;

const int ts=13;
char *statustext="";
bool warover=false;
bool quit=false;
bool leave=false;

vector<string> emergencymessages;

char *nulltext="";

BITMAP *fontbmp[36];
BITMAP *redfontbmp[36];
BITMAP *ghetto;
BITMAP *ghetto2;
int emergencytimer=0;//used for displaying emergency messages in the statusbar

BITMAP *cursorbmp;
BITMAP* background;

void enable_buttons();

const int flamecyclelength=5;
int flamecycle[flamecyclelength];
const int flameboxes[4][4] = {
{73,18,102,44},
{72,8,113,16},
{106,18,129,42},
{89,47,127,61}
};
bool changeflame=false;

int flame[50][3];

int consequences=0;


#include "dynamics.hpp"
#include "widgets.hpp"
#include "dialog.hpp"

vector <Screen_Element*> elementarray;
Screen_Element *capturing=NULL;

void enable_buttons()
{
	foreach(Screen_Element* e,elementarray)
	{
		e->enable();
	}
}

void mouse_input()
{
	int mx=mouse_x/4;
	int my=mouse_y/4;
	bool mb1=mouse_b&1;
	
	if (capturing==NULL)
	{
		statustext=nulltext;
		foreach (Screen_Element* el, elementarray)
		{
			if (el->isat(mx,my) && el->enabled)
			{
				statustext=el->tooltip;
				if (el->mouseinput(mx,my,mb1))
				{
					capturing=el;
					el->focused=true;
					break;
				}
			}
			else
				el->focused=false;
		}
	}
	else
	{
		if (!capturing->mouseinput(mx,my,mb1))
		{
			capturing=NULL;
			statustext=nulltext;
		}
	}
}

void process_emergencies()
{
	if (emergencytimer==0)//check if there's something
	{
		if (!emergencymessages.empty())
		{
			emergencytimer=150;
		}
			
	}
	else
	{
		emergencytimer--;
		if (emergencytimer==0)
		{
			emergencymessages.erase(emergencymessages.begin());
		}
	}
	
}

void drawGUI()
{		
	foreach (Screen_Element* el, elementarray)
	{
		el->draw();
	}
	
}

void drawCursor()
{
	int mx=mouse_x/4;
	int my=mouse_y/4;
	masked_blit(cursorbmp,buffer,0,0,mx,my,5,7);
	
}

struct Preface_Info {
	bool big;
	string text;
	int time;
};

vector<Preface_Info> prefacetexts;

void drawPreface()
{	
	if (prefacetexts[0].big)
		textout_ex(buffer,font,prefacetexts[0].text.c_str(), 10, 50, makecol(255,0,0), makecol(0,0,0));
	else
	{
			int i=0;
			while (prefacetexts[0].text.c_str()[i]!=0)
			{
				if (prefacetexts[0].text.c_str()[i]!=' ')
					masked_blit(redfontbmp[chartonum(prefacetexts[0].text.c_str()[i])],buffer,0,0,4+1+4*i,40+10,3,5);
				i++;
			}
	}
}


void introloop()
{
	int titletimer=0;
	
	
	position_mouse(400,200);
	
	
	while (!quit&&!warover)
	{
		
		al_poll_duh(dplay);	

    	while(speed_count>0){
			
			poll_mouse();
			
			titletimer++;
			
			
			if (key[KEY_ESC])
				quit=true;
			if (titletimer>60||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				return;
			}
			
		      speed_count--;
		}
		
		clear_to_color(buffer,makecol(245,233,162));
				
		textout_ex(buffer, font, "increpare presents", 4, 50, makecol(0,0,0), makecol(245,233,162));
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
}


void titleloop()
{
	position_mouse(400,100);
	
	bool begin=false;
	elementarray.clear();
	elementarray.push_back( new Set_Button(62,64,36,17,titlebutton[0],"play new game",true,true,&begin));
	elementarray.push_back( new Set_Button(62,85,36,17,titlebutton[1],"play new game",true,true,&quit));
	
	while (!begin && !quit)
	{
		
		al_poll_duh(dplay);	
		
		while(speed_count>0)
		{
		
			
			poll_mouse();
			
			if (key[KEY_ESC])
				quit=true;
			mouse_input();

		      speed_count--;
		} 
		
		
		blit(titlescreen, buffer, 0, 0, 0, 0, 160, 120);
		
		drawGUI();
		
		
		drawCursor();
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
	delete elementarray[0];
	delete elementarray[1];
	elementarray.clear();
	
}


void prefaceloop()
{
     string message[4]={
            "warsaw has finally fallen",
            "we have established a new government",
            "rule it well",
            "" 
            };
	position_mouse(400,100);
	
	bool done=false;
	elementarray.clear();
	elementarray.push_back( new Set_Button(73,93,ts,ts,bitmaparray[13],"play new game",true,true,&done));
	
	while (!done && !quit)
	{
		
		al_poll_duh(dplay);	
		
		while(speed_count>0)
		{
			
			poll_mouse();
			
			if (key[KEY_ESC])
				quit=true;
			mouse_input();
			
			      speed_count--;
		} 
		clear_to_color(buffer,makecol(245,233,162));
		
		drawGUI();
		
			for (int j=0;j<4;j++)
			{
				int i=0;
				while (message[j].c_str()[i]!=0)
				{
					if (message[j].c_str()[i]!=' ')
						masked_blit(fontbmp[chartonum(message[j].c_str()[i])],buffer,0,0,4+1+4*i,10+20+20*j,3,5);
					i++;
				}
			}
			
		drawCursor();
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
	delete elementarray[0];
	elementarray.clear();
	
}

void gameloop()
{
	if (quit)
		return;

	init_gamevars();
	
	
	position_mouse(400,200);
	
	
	while (!quit&&!leave&&!warover)
	{
		
		al_poll_duh(dplay);	

		while(speed_count>0)
		{
			poll_mouse();
			
			mouse_input();
			
			if (key[KEY_ESC])
				quit=true;
			
			int i=do_logic();
			if (i!=0)
			{
				consequences=i;
				warover=true;
			};
			
			process_emergencies();
			
		      speed_count--;
		}
		
		blit(background, buffer, 0, 0, 0, 0, 160, 120);
		//		clear_to_color(buffer,makecol(150,50,50));
		
		drawGUI();
		
		drawCursor();
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
}

void gameoverloop()
{
	if  (!warover)
		return;
	warover=false;
	
	string message[4]={"","","",""};
	switch (consequences)
	{
		case 0:
			message[0]= "when the russians arrived";
			message[1]="they defeated the general government";
			break;
		case 1:
			message[0]= "the general government went bankrupt";
			message[1]= "and collapsed";
			break;
		case 2:
			message[0]= "the general government was overthrown";
			message[1]= "by the brave people of warsaw";
			break;
	}
	
	position_mouse(400,100);
	
	bool done=false;
	elementarray.clear();
	elementarray.push_back( new Set_Button(73,93,ts,ts,bitmaparray[13],"play new game",true,true,&done));
	
	while (!done && !quit)
	{
		
		al_poll_duh(dplay);	
		
		while(speed_count>0)
		{
			poll_mouse();
			
			if (key[KEY_ESC])
				quit=true;
			mouse_input();
			
		      speed_count--;
		};
		
  		clear_to_color(buffer,makecol(245,233,162));
		
		drawGUI();
		
		for (int j=0;j<4;j++)
		{
			int i=0;
			while (message[j].c_str()[i]!=0)
			{
				if (message[j].c_str()[i]!=' ')
					masked_blit(fontbmp[chartonum(message[j].c_str()[i])],buffer,0,0,4+1+4*i,10+20+20*j,3,5);
				i++;
			}
		}
		
		drawCursor();
		
		stretch_blit(buffer,screen,0,0,160,120,0,0,640,480);
		
	}
	
	delete elementarray[0];
	elementarray.clear();
	
}

BITMAP *barimage;
BITMAP *poleflag;
BITMAP* inputimagesarray[4];
BITMAP* xbuttonbmp;

void init()
{
	
	/* initialise everything */
	allegro_init();
	init_sound();
	
	//	int depth = desktop_color_depth();
	
	//	if (depth == 0) depth = 32;
	//		set_color_depth(depth);	
	set_color_depth(32);
	
	install_keyboard();
	install_mouse();
	install_timer();
	
	
	
//mac	CGDisplayHideCursor(kCGDirectMainDisplay);
	
	set_alpha_blender();
	
    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(30));	
	
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;
	
	//init the buffer
	buffer=create_bitmap(160,120);
	
	//load font
	
	BITMAP* fontbmps =  load_bitmap("bmp/font.bmp", NULL);
	BITMAP* redfontbmps =  load_bitmap("bmp/font2.bmp", NULL);
	for (int i=0;i<36;i++)
	{
		fontbmp[i]=create_bitmap(3,5);
		blit(fontbmps,fontbmp[i],i*4,0,0,0,3,5);
		redfontbmp[i]=create_bitmap(3,5);
		blit(redfontbmps,redfontbmp[i],i*4,0,0,0,3,5);
	}
	
	delete fontbmps;
	delete redfontbmps;
	
	BITMAP* titlebuttons = load_bitmap("bmp/titlebuttons.bmp",NULL);
	
	for (int i=0;i<2;i++)
	{
		titlebutton[i]=create_bitmap(36,68);
		blit(titlebuttons,titlebutton[i],i*36,0,0,0,36,68);
	}
	
	delete titlebuttons;
	
	//button
	BITMAP* buttonbmps = load_bitmap("bmp/buttons.bmp", NULL);
	xbuttonbmp = load_bitmap("bmp/xbtn.bmp",NULL);
	for (int i=0;i<14;i++)
	{
		if (i==0||i==4 || i==2 || i==5 || i==11||i==7 ||i==13)
		{
			bitmaparray[i]=create_bitmap(13,52);
			blit(buttonbmps,bitmaparray[i],i*13,0,0,0,13,52);
		}
		else
		{
			bitmaparray[i]=create_bitmap(13,13);
			blit(buttonbmps,bitmaparray[i],i*13,2*13,0,0,13,13);
			
		}
	}
	
	delete buttonbmps;
	
	BITMAP* inputimages = load_bitmap("bmp/inputimages.bmp",NULL);
	for (int i=0;i<4;i++)
	{
		inputimagesarray[i]=create_bitmap(13,13);
		blit(inputimages,inputimagesarray[i],i*13,0,0,0,13,13);
	}
	delete inputimages;
	
	
	delete inputimages;
	
	barimage=create_bitmap(ts,ts);
	blit(buttonbmps,barimage,0,0,0,0,ts,ts);
	poleflag=create_bitmap(13,10);
	blit(bitmaparray[6],poleflag,0,1,0,0,13,10);

	
	cursorbmp = load_bitmap("bmp/cursor.bmp",NULL);
	
	background = load_bitmap("bmp/background.bmp",NULL);
	titlescreen = load_bitmap("bmp/titlescreen.bmp",NULL);
	
	
	
	ghetto = load_bitmap("bmp/ghetto.bmp",NULL);
	ghetto2 = load_bitmap("bmp/ghetto2.bmp",NULL);
	
	
	flamecycle[0]=makecol(237,28,36);
	flamecycle[1]=makecol(255,246,127);
	flamecycle[2]=makecol(252,167,38);
	flamecycle[3]=makecol(238,42,36);
	flamecycle[4]=makecol(212,49,39);
	
	srand(time(0));

}

void init_gamevars()
{
	std::cout<<"A";
	
	consequences=false;
	warover=false;
	leave=false;
	if (warsaw!=NULL)
		delete warsaw;
	warsaw = new Warsaw;
	
	for (int i=0;i<50;i++)
	{
		int r=rand()%4;
		flame[i][0]=flameboxes[r][0]+(rand()%(flameboxes[r][2]-flameboxes[r][0]));
		flame[i][1]=flameboxes[r][1]+(rand()%(flameboxes[r][3]-flameboxes[r][1]));
		flame[i][2]=flamecycle[rand()%flamecyclelength];
	}
	
	
	
	{//constructor stuff
		
		
		for (unsigned int i=0;i<elementarray.size();i++)
		{
			delete elementarray[i];
		}
		elementarray.clear();
		
		
		elementarray.push_back(new Set_Button(7,2,7,7,xbuttonbmp,"quit",true,false,&leave));
		
		elementarray.push_back(new Toggle_Button(4,11,ts,ts,bitmaparray[4],"abolish secondary education",true,true,&warsaw->educationban));
		elementarray.push_back(new Set_Button(18,11,ts,ts,bitmaparray[2],"establish jewish quarter",true,true,&warsaw->ghetto));
		elementarray.push_back(new Set_Button(32,11,ts,ts,bitmaparray[0],"construct wall",false,true,&warsaw->wall));
		elementarray.push_back(new Toggle_Button(4,25,ts,ts,bitmaparray[5],"mandate the jewish badge",true,true,&warsaw->jewbadge));
		elementarray.push_back(new Toggle_Button(18,25,ts,ts,bitmaparray[11],"mandate the polish badge",true,true,&warsaw->polebadge));
		elementarray.push_back(new Toggle_Button(32,25,ts,ts,bitmaparray[7],"start the trains",false,true,&warsaw->trains));
		
		elementarray.push_back(new Singlebar(4, 40, 41,ts, ts, bitmaparray[10], "total population",&warsaw->population));
		elementarray.push_back(new Doublebar(4, 54, 41,10, ts, poleflag, "polish population in and out of ghetto", warsaw->polishpop));
		elementarray.push_back(new Doublebar(4, 65, 41,ts, ts, bitmaparray[1], "jewish population in and out of ghetto", warsaw->jewishpop));
		elementarray.push_back(new Singlebar(4, 79, 41,ts, ts, bitmaparray[12], "german population", &warsaw->germanpop));
		elementarray.push_back(new Singlebar(4, 93, 41,ts, ts, bitmaparray[9], "treasury funds remaining", &warsaw->budget));
		
		elementarray.push_back(new Inputbar(53, 79, 50, ts, ts, inputimagesarray[0], "tax rate", 10,&warsaw->tax));
		elementarray.push_back(new Inputbar(106, 79, 50, ts, ts, inputimagesarray[1], "propaganda budget", 10,&warsaw->propaganda));
		elementarray.push_back(new Inputbar(53, 93, 50, ts, ts, inputimagesarray[2], "military population", 10,&warsaw->military));
		elementarray.push_back(new Inputbar(106, 93, 50, ts, ts, inputimagesarray[3], "german immigration rate", 10,&warsaw->immigration));
		
		elementarray.push_back(new Status_Bar(4	,110,154,7,"statusbar"));
		
		elementarray.push_back(new MapView(49,0,111,77,"view of warsaw"));
		elementarray.push_back(new Date_Display(17,2,25,7,"date"));
		
	}
	
	std::cout<<"B";
}

int main(int argc, char *argv[])
{
	init();

	introloop();
	
	playmusic(1);	
	while (!quit)
	{
		titleloop();
	
	    prefaceloop();
	    
		gameloop();
		
		gameoverloop();
	}
	
	return 0;
}
END_OF_MAIN()
